#include	"ksysdefs.h"
#include	"ksysvtyp.h"
#include	"ksysprot.h"
#include	"kawkdefs.h"
/**/
#include	"kawkfunc.h"
/*EXTERN*/
/*STATIC*/
#ifdef	CAN_PROTO
static char *month(char *, char *, char *);
static char *year(char *, char *, char *);
static char *day(char *, char *, char *);
#else
static char *month();
static char *year();
static char *day();
#endif
/**/
static	char	*mname[] = {
	"January",
	"February",
	"March",
	"April",
	"May",
	"June",
	"July",
	"August",
	"September",
	"October",
	"November",
	"December",
}	;
char	*
fmonth(is)
char	*is;
{
	auto	int	ix;
	auto	int	nx = sizeof(mname)/sizeof(char *);
	static	char	ms[3];
	for(ix = 0; ix < nx; ix++)
	if(is[0] == *mname[ix] &&
		strnkmp(is,mname[ix],3) == 0)	{
			itos(ms,ix+1);
			return(ms);
			}
	return(is);
}
char	*
undater(os,us,is)
char	*os;
char	*us;
char	*is;
{
#define	SMLBLK	128
	auto	char	*ma;
	auto	char	*mb;
	auto	char	*da;
	auto	char	*mo;
	auto	char	*yr;
	auto	char	*osx = os;
	da = mo = yr = "";
	*osx = ZERO;
/*
**	convert dates of the form
**	day month year
**	month year
**	month-month year
**	season year
*/
	if(isdigit(*is))	is = strtoc(da = is,' ');
	if(isalpha(*is))	is = strtoc(mo = is,' ');
	if(isdigit(*is))	is = strtoc(yr = is,' ');
	if(isnull(yr))	{
		yr = da;
		da = NULL;
		}
	if(!isnull(yr))	{
		os = strkat(os,us,yr);
		}
	if(!isnull(mo))	{
		if(!isnull(yr))	os = strkat(os,us,":");
		mb = strtoc(ma = mo,'-');
		os = strkat(os,us,fmonth(ma));
		if(!isnull(mb))	{
			os = strkat(os,us,"-");
			os = strkat(os,us,fmonth(mb));
			}
		}
	if(!isnull(da))	{
		os = strkat(os,us,":");
		os = strkat(os,us,da);
		}
	return(osx);
}
char	*
dater(os,us,is)
char	*os;
char	*us;
char	*is;
{
/*
**	convert dates of the following forms
**	year:season			season year
**	year:month:day		day month year
**	year:month			month year
**	year:month-month	month-month year
*/
	return(year(os,us,is));
}
static	char	*
year(os,us,is)
char	*os;
char	*us;
char	*is;
{
	auto	char	*co;
	if((int)(co = strchr(is,':')))	{
		*co++ = ZERO;
		os = month(os,us,co);
		}
	os = strkat(os,us,is);
	os = strkat(os,us," ");
	return(os);
}
static	char	*
month(os,us,is)
char	*os;
char	*us;
char	*is;
{
	auto	char	*co;
	auto	int	nm;
	if((int)(co = strchr(is,':')))	{
		*co++ = ZERO;
		os = day(os,us,co);
		}
	while(isspace(*is))	++is;
	if(isalpha(*is))	{
		os = strkat(os,us,is);
		os = strkat(os,us," ");
		return(os);
		}
	while(*is != ZERO)
	if(isdigit(*is))	{
		nm = atoi(is) - 1;
		if(nm >= 0 && nm <= 11)	{
			os = strkat(os,us,mname[nm]);
			}
		while(isdigit(*is))	++is;
		if(*is == '-')	{
			os = strkat(os,us,"-");
			is += 1;
			}
		else	os = strkat(os,us," ");
		}
	else
	if(isspace(*is))	++is;
	else		{
		os = strkat(os,us,is);
		break;
		}
	return(os);
}
static	char	*
day(os,us,is)
char	*os;
char	*us;
char	*is;
{
	while(isspace(*is))	++is;
	if(!isnull(is))	{
		os = strkat(os,us,is);
		os = strkat(os,us," ");
		}
	return(os);
}
#ifdef	TEST
main()
{
	auto	char	ls[BLKSIZ];
	auto	char	os[BLKSIZ];
	auto	char	xs[BLKSIZ];
	while(putchar('?'),fflush(ls),gets(ls))	{
	strcpy(xs,ls);
	dater(os,os+BLKSIZ,xs);
	puts(os);
	strcpy(xs,ls);
	undater(os,os+BLKSIZ,xs);
	puts(os);
	}
	exit(0);
}
#endif
