#
#   work/scratch arrays used in the program
#
int     memo;       /* switch for memos */
int     loc;        /* switch for loc */
int     cnt;        /* card count */
int     aut;        /* authorship */
int     per;        /* periodical */
char    la[BUFSIZ];
char    lb[BUFSIZ];
char    rs[BUFSIZ];
/*
**  to turn on memos, add 
    memo = 1;
**  to turn on locs, add
    loc = 1;
*/
{
#
#   puts could also be used for these constant strings
#
    printf(".bp +0\n.hy 8\n.na\n");
#
#   note the use of %B and %R as alternatives to
#   \\fB and \\fR
#
    printf(".bp +0\n.sp 4\n.ce\n%BBIBLIOGRAPHY%R\n.sp 4\n");
#
#   an explicit loop to read cards is required in kawk
#
    cnt = 0;
    while(rdcard()) {
    cnt += 1;
    printf("\n.BR\n");
    aut = orlist($aut,$ca);
    if(aut && strcmp(la,$a) == 0)  printf("--------.\n");
    else
    if(aut)  {
#
#   get rid of ".." and other garbage in the author
#   case
#
#   note that sformat in kawk requires a size parameter
#
        sformat(lb,512,"%s.",aut);
        litrep(lb,512,lb,"..",".",0);
        litrep(lb,512,lb," .",".",0);
        puts(lb);
    }
#
#   %S is used to call the internal folding function;
#   %s is equally acceptable
#
    if($at)                 printf("%Q%S.%Q\n",$at);
    if($at && $vt)          printf("In ");
    if($vt)                 printf("%B%S%R.\n",$vt);
    if($tr)                 printf("Translated by %s.\n",$tr);
    if($ved)                printf("Edited by %s.\n",reverse(rs,BUFSIZ,$ved));
    if($vnum && $col)       printf("Vol. %s in %B%S%R.\n",$vnum,$col);
    per = orlist($s,$m,$ne);
    if(per)                 printf("%B%S%R.\n",per);
    if($vin)                printf("%s ",$vin);
    if($date && $pp)        printf("(%s): %s.\n",$date,$pp);
    else
    if($date && !$pp)       printf("(%s).\n",$date);
    if($pub && $yop)        printf("(%s, %s).\n",$pub,$yop);
    else
    if($pub && !$yop)       printf("(%s).\n",$pub);
    else
    if(!$pub  && $yop)      printf("(%s).\n",$yop);
    if($vt && $pp)          printf("Pp. %s.\n",$pp);
    if(memo && $memo)       printf(".IP\n%S\n",$memo);
    if(loc && $loc)         printf(".IP CALL\n%s\n",$loc);
    if(aut)                 strcpy(la,aut);
    }
    /*printf("cnt = %d\n",cnt);*/
    exit(0);
}
