#include    "ksysdefs.h"
#include    "ksysvtyp.h"
/**/
#include    "keddefs.h"
#include	"ksysprot.h"
#include	"kedvars.h"
#include	"kedfuncs.h"
/**/
/*EXTERN*/
extern	long	filesize();
/**/
doread(nc,is)    /* read from an external file */
int     nc;
char    *is;
{
    auto    char    ws[FNMSIZ];
	auto	char	*fn;
    cdx.con = YES;
    if(isnull(is))  strcpy(ws,efn);
    else            {
		auto	char	*fn = fexpand(is);
		strcpy(ws,fn);
		fn = free_if(fn);
		}
    if(isnull(ws))  {
        errmsg("<no file name>\n");
        cdx.con = NO;
        cdx.cur = cdx.cur <= cdx.lst ? cdx.cur : cdx.lst;
        terror(FUBAR);
    }
	addcds(nc,ws);
    cdx.del = cdx.chg = YES;
    if(isnull(efn)) {
        efnset(ws);
        tellfile(1);
    }
    return(cdx.con);
}
/**/
doedit(is)
char *is;
{
    cdx.con = YES;
    if(*is == '!')  {
        cdx.chg = NO;
		orphans('u',"doedit",NULL);
        is += 1;
    }
    if(cdx.chg) {
		printff("\007<unwritten changes - e! overrides>\n");
        terror(FUBAR);
        }
    is = efnset(strcnd(is));
    clredit();
    return(bufbld(is));
}
/**/
dojoin(n1,n2,is)
int	n1;
int	n2;
char    *is;
{
	auto	int	i;
	auto	int	ty = 'a';
	auto	char	*isx = is;
/***set join type***/
	while(*isx != ZERO)
	switch(*isx)	{
	case	'a':
	case	'o':
	case	's':
					ty = *isx; 
	default:		isx += 1;
					break;
	}
/***clear card, then read with appropriate type***/
	clcd();
	for(i = n1; i <= n2; i++)   {
		if(getcd(i,ty))			terror(FUBAR);
	}
	delcd(n1 + 1, n2,"");
	if(!chgcd(cdx.cur = n1, CARD_IO))	terror(FUBAR);
	cdx.chg = cdx.del = 1;
/***prlist is called even if no print is specified***/
	prlist(cdx.cur,cdx.cur,is);
	return(cdx.con = YES);
}
