/*
	88:12:07
	rewritten to avoid dolist - this causing double closure of
	files and core dumps when fflush was given NULL
*/
#include	"kwheader.h"
/**/
/**/
#include	<sys/types.h>
#include	<sys/stat.h>
/*EXTERN*/
/*GLOBAL*/
/**/
main(argc,argv)
int     argc;
char    *argv[];
{
	kenv.dosdos = isdos();
	disnme(kenv.pname = "kwed");
	exit(cmdxrc(argc,argv,kwed,"kwed.xrc"));
	return(0);	/* LINT */
}
kwed(argc,argv)
int		argc;
char	*argv[];
{
	auto	int		size;
/**/
	setbuf(stdout,emalloc(bufsiz(),"main"));
/**/
	if(kenv.dosdos)	cmdxpd(argc,argv);
	else			telluser(kenv.pname);
/**/
	if(cmdnum(argc,argv,'h',0,1))	exit(hint(ZERO));
/**/
	disrec(cmdnum(argc,argv,'R',1,0));
/**/
	tmpdir = (int) (tmpdir = kgetenv("TMPDIR")) ? tmpdir : ".";
	wfn = emalloc(FNMSIZ,"main");
	strcpy(wfn,tmpdir);
	strcat(wfn,"/kwXXXXXX.tmp");
/**/
	maketemp(wfn);
/**/
	wb = emalloc(bufsiz(),"dofile");
	rb = emalloc(bufsiz(),"dofile");
	rmode = kenv.dosdos ? "rb" : "r";
	wmode = kenv.dosdos ? "wb" : "w";
/**/
	kenv.talarm = cmdnum(argc,argv,'A',600,600);
	kenv.flags0 = cmdnum(argc,argv,'m',DA,0);
	kenv.flags1 = cmdnum(argc,argv,'a',0,DA);
/**/
	size = cmdnum(argc,argv,'B',4096,4096);
	bufc = bufo = emalloc(size,"main");
	bufu = bufo + size;
/**/
	verb = cmdnum(argc,argv,'v',DA,DA);
	undo = cmdnum(argc,argv,'u',0,DA);
/**/
	if(signal(SIGINT,SIG_IGN) != SIG_IGN)	{
#ifdef	MSDOS
#else
		signal(SIGALRM,terror);
		signal(SIGHUP,terror);
#endif
		signal(SIGINT,terror);
		}
/**/
	if(cmdnum(argc,argv,'r',0,DA))
		geterrs(cmdstr(argc,argv,'r',NULL));
	else
	if(cmdnum(argc,argv,'e',0,DA))
		geterx(cmdstr(argc,argv,'e',NULL));
/**/
	dofiles(cmdlist(argc,argv,ZERO,NULL));
	dofiles(sofiles);
/**/
	if(verb)	{
		changes(NULL);
		}
	unlink(wfn);
	exit(0);
}
dofiles(is)
char	*is;
{
	auto	int     nsub = 0;	/* one file */
	auto	int		tsub = 0;	/* all files */
	auto	char	*isx = is;
	auto	char	ws[FNMSIZ];
/**/
	if(isnull(is))	return(tsub);
/*
		OPEN WORK FILES, READ INPUT
*/
	while((int)(isx = xgnc(efn = ws,ws+FNMSIZ-1,isx,' ')))	{
/**/
		if(!kenv.dosdos)	alarm(kenv.talarm);
/**/
		if(filesize(efn) <= 0L)	{
/**/
			prwho(" <does not exist or zero> '%s'\n",efn);
			if(kenv.flags1)	{
				errmsg("<aborted for file error>\n");
				terror(FUBAR);
				}
/**/
			continue;
			}
/**/
		wfp = tefopen(wfn,wmode);
/**/
		efp = tefopen(efn,rmode);
/**/
		setbuf(efp,rb);
		setbuf(wfp,wb);
/**/
		nsub = dochg(wfp,efp);
		tsub += nsub;
/**/
		wfp = xfclose(wfp);
		efp = xfclose(efp);
/**/
		if(nsub)		linkorcopy(wfn,efn);
		if(verb)		print(" %4d changes %s\n",nsub,efn);
	}
	return(tsub);
}
geterrs(is)
char	*is;
{
	auto	char    ls[FNMSIZ];
	auto	FILE	*fp;
/**/
	fp = tefopen(is,rmode);
/**/
	nerrs = 0;
/**/
	while(fgetlf(ls,ls+FNMSIZ-1,fp))	{
		if(nerrs >= NERRS)	{
			errmsg("geterrs <too many script items> %d %d\n",
				nerrs,NERRS);
			break;
			}
		nerrs = adderrs(ls);
		}
/**/
	fp = xfclose(fp);
/**/
	return(nerrs);
}
adderrs(is)
char	*is;
{
	auto	char    ss[FNMSIZ];
	auto	char    *wp[4];
	auto	int	xp;
	auto	char	*cx;
	auto	char	*ex;
	strcpy(ss,is);
	xp = splitc(wp,4,is,is[0]);
	if(xp != 3 || strlen(wp[0]) <= 0)	{
		errmsg("geterrs <bad form> '%s'\n",ss);
		terror(FUBAR);
		}
	if(undo)	{
		cx = xl[nerrs].cor = strsave(wp[0]);
		ex = xl[nerrs].err = strsave(wp[1]);
		}
	else	{
		ex = xl[nerrs].err = strsave(wp[0]);
		cx = xl[nerrs].cor = strsave(wp[1]);
		}
	if(!ex || !cx) {
		errmsg("<geterrs: no core>\n");
		terror(FUBAR);
	}
	strrev(xl[nerrs].cor);
	xl[nerrs].siz = strlen(xl[nerrs].cor);
	nerrs += 1;
	return(nerrs);
}
changes(is)   /* REPORT CHANGES */
char	*is;
{
	REG NOSIGN	 i;
	for(i = 0; i < nerrs; i++) {
		strrev(xl[i].cor);
		print("%3d /%s/%s/\n",xl[i].ncor,xl[i].err,xl[i].cor);
		xl[i].ncor = ZERO;
		strrev(xl[i].cor);
	}
	return(ZERO);
}
cmpword(os,is)  /* COMPARE "WORDS" */
char	*os;	/* word from input line */
char	*is;	/* error from inxl */
{
	REG char    *osx = os;
	REG char    *isx = is;
	while(*isx != ZERO && *osx == *isx)	{
		osx++;
		isx++;
		}
	if(*isx != ZERO)    return(0);
	if(*osx == '^')		return(0);
	if(isspace(*osx))   return(1);
	if(ispunct(*osx))   return(1);
	if(iscntrl(*osx))   return(1);
	if(*osx == ZERO)    return(1);
	return(0);
}
dochg(ofp,ifp)
FILE    *ofp;
FILE    *ifp;
{
	REG		int     subtf = 0;
	auto	char	*fn;
/**/
	while(fgetls(bufo,bufu,ifp))	{
		if(source(bufo))	{
			strcnd(bufo+4);
			sofiles = stradd(sofiles,bufo+4);
		}
		else	{
			subtf += wordsub(bufo);
		}
		fputs(bufo,ofp);
		fputs("\n",ofp);
	}
/**/
	fflush(ofp);
	return(subtf);
}
geterx(is)
char    *is;
{
	return(adderrs(is));
}
inxl(is)		/* is the word _is in the error list */
char    *is;
{
	REG     char    	*isx = is;
	REG     NOSIGN	    i;
	for(i = 0; i < nerrs; i++)
		if(*isx == *xl[i].err &&
			cmpword(isx+1,xl[i].err+1)) return(i);
	return(-1);
}
void
terror(ty)
/*###258 [cc] redeclaration of terror%%%*/
int		ty;
{
	static	NOSIGN	loop = ZERO;
	if(loop++ >= BUFSIZ)	exit(FUBAR);
/**/
	efclean(NULL);
/**/
	unlink(wfn);
/**/
	errmsg("terror(%u)\n",ty);
/**/
	exit(ty);
}
#define		isfont(x)((x[0] == '\\' && x[1] == 'f' && isupper(x[2])) ? 1 : 0)
wordsub(os)
char    *os;
{
	REG     char    *osx = os;
	REG		int     lp = 0;
	auto	int		nsub = 0;
	while(*osx != ZERO) {
/*	find the beginning of a word */
	if(isalpha(*osx))	{
/*      is this item in the error list? */
		if((lp = inxl(osx)) >= 0) {
/*          remove the word from the string */
			strcpy(osx,osx + strlen(xl[lp].err));
/*          reverse the changed string */
			strrev(osx);
/*          append previously reversed correction to osx */
			strcat(osx,xl[lp].cor);
/*          reverse the whole string */
			strrev(osx);
			if(verb & DB)	printff("(%s) %s\n",xl[lp].err,os);
/*          advance osx by size of replacement */
            if(xl[lp].siz)	osx += xl[lp].siz;
            else			osx += 1;
/*          increment the change count */
			xl[lp].ncor += 1;
			nsub++;
			continue;
			}
/*      go to next word */
		while(isalpha(*osx))	osx += 1;
		}
	else
	if(isfont(osx))	osx += 3;
	else			osx += 1;
	}
	return(nsub);
}
