#define		SETCBRK
/*
	89:02:19	fixed NULL assignments in newcmp
	89:07:07	fixed 'u' option
	89:07:07	fixed point misalignment
	89:07:07	revised progress reporting.
*/
#define		USEV
#ifndef		SYSV
#undef		USEV
#endif		/*SYSV*/
/*DOSLIB*/
#include	"ksysdefs.h"
#include	"ksysvtyp.h"
#include	"ksysprot.h"
/**/
#define		MEMORY		4096
/**/
#ifdef		MSDOS
#include	<dos.h>
#endif		/*MSDOS*/
#include	<signal.h>
/**/
#define		SWORK	"/ksXXXXXX.tmp"
/**/
#define		HUGE	9999
#define		ZERO	0
#define		NSORT	8	/* maximum number of sorts */
#define		SREVR	1	/* reverse order */
#define		SBLNK	2	/* skip leading blanks */
#define		SDICT	4	/* dictionary sort */
#define		SNUMR	8	/* numerical sort */
#define		SFOLD	16	/* fold case */
#define		SUNIQ	32	/* uniq */
#define		NPART	32	/* number of merge partitions */
#define		MEMSIZ	( (long) (BUFSIZ * 30) )
/**/
typedef	struct	MERGE		{
	long	m_start;		/* start of merge partition */
	long	m_lines;		/* number of lines in partition */
	}	MERGE;
MERGE	merge[NPART];
int		npart;				/* parts in merge */
int		mpart;
typedef	struct	SORTSPEC	{
	int	sfield;		/* starting field */
	int	efield;		/* ending field */
	int	soffst;		/* starting offset */
	int	eoffst;		/* ending offset */
	int	sspecs;		/* sort specs */
}	SORTSPEC;
/**/
typedef	struct		DICT	{
	char		*data;	/* where we record words */
	char		*base;	/* base of recording array */
	char		**line;	/* where we record lines */
	unsigned	numl;	/* number of lines */
	unsigned	size;	/* size of data area (original) */
	}	DICT;
DICT	dict;
/**/
SORTSPEC	spx[NSORT];
long		tbeg;
long		tend;
long		tline;
long		npass;		/* number of passes */
long		nassp;		/* report every nassp */
int			nsort;		/* number of sorts */
int			fc = ' ';	/* field separator character */
char		*action;
char		*(*xact)()	=	strupr;
char		*ifn;		/* input file names */
char		*ofb;		/* output file buffer */
char		*wfb;		/* work file buffer */
int			funiq;		/* uniq filter */
char		*ofn;		/* out file name (NULL = stdout) */
char		wfn[FNMSIZ];
char		ps[BUFSIZ];	/* previous string */
FILE		*ofp;		/* ultimate output file */
FILE		*wfp;		/* work file */
char		*dta;
KENV		kenv;
char		*tmpdir;
char		**lp;
int			nlc;		/* number of lines in merge partition */
int			nlp;		/* number of line pointers allocated */
long			tcc;
/*EXTERNAL*/
#ifdef	CAN_PROTO
#ifdef	__TURBOC__
#include	<stdio.h>
#include	<alloc.h>
#else	/*__TURBOC__*/
extern void qsort(char *,int,int ,int ( *)());	/*SHIT*/
extern double atof(char *);	/*SHIT*/
#endif	/*__TURBOC__*/
extern void showstat();
extern void prwho();
extern void errmsg();
extern char *ksetvbuf(FILE *,char *,NOSIGN,NOSIGN);
extern int ksort(int,char **);
extern char *blankit(char *);
extern char *dictit(char *);
extern char *getfield(char *,char *,int,int ,int);
extern char *getmerge(int);
extern int mergesort(void);
extern void dumpline(FILE *);
extern int hint(int);
extern void makeline(NOSIGN);
extern int newcmp(char *,char *,int,SORTSPEC *,int);
extern int numcmp(char *,char *);
extern int pullfield(char *);
extern int pullflag(char *);
extern int pulloffst(char *);
extern int readline(FILE *);
extern int saveline(char *);
extern int setsort(int,char *[0]);
extern int sorter(char * *,char * *);
extern int sortline(int);
extern void ssort(char *,int,int ,int ( *)());
extern void terror(int);
extern int wrtmerge(char *);
#else	/*CAN_PROTO*/
extern void showstat();
extern double atof();
extern void prwho();
extern void errmsg();
extern char *ksetvbuf();
extern char *blankit();
extern char *dictit();
extern char *getfield();
extern char *getmerge();
extern int mergesort();
extern void dumpline();
extern int hint();
extern void makeline();
extern int newcmp();
extern int numcmp();
extern int pullfield();
extern int pullflag();
extern int pulloffst();
extern void qsort();
extern int readline();
extern int saveline();
extern int setsort();
extern int sorter();
extern int sortline();
extern void ssort();
extern void terror();
extern int wrtmerge();
extern int ksort();
#endif	/*CAN_PROTO*/
/**/
void
terror(ty)		/* clean up */
int	ty;
{
	unlink(wfn);
	if(ty != 0) errmsg("<killed by signal> '%u'\n",ty);
	exit(ty);
}
/**/
main(argc,argv)
int		argc;
char	*argv[];
{
	kenv.dosdos = isdos();
	disnme(kenv.pname = "ksort");
	return(cmdxrc(argc,argv,ksort,"ksort.xrc"));
}
ksort(argc,argv)
int		argc;
char	*argv[];
{
/**/
	if(kenv.dosdos)	{
		cmdxpd(argc,argv);
#ifdef	SETCBRK
		setcbrk(YES);
#endif
		}
	else			telluser(kenv.pname);
/**/
	disrec(cmdnum(argc,argv,'R',1,0));
/**/
	if(cmdnum(argc,argv,'h',0,DA))	{
		if(isatty(1))	{
			kenv.leisur = DA | DB;
			whoru(stdout);
			query(stdout);
			}
		hint(0);
		}
/**/
	kenv.blockd = cmdnum(argc,argv,'P',4,4) * bufsiz();
/**/
	kenv.diagno = cmdnum(argc,argv,'D',0,DA);
/**/
	if(kenv.dosdos)	cmdxpd(argc,argv);
/**/
	ofn = cmdstr(argc,argv,'o',kgetenv("OUTFILE"));
/**/
	tmpdir = cmdstr(argc,argv,'T',kgetenv("TMPDIR"));
	if(isnull(tmpdir))	{
		if(kenv.dosdos)	tmpdir = strsave(".");
		else			tmpdir = strsave("/usr/tmp");
		}
	else				tmpdir = strsave(tmpdir);
/**/
	strcpy(wfn,tmpdir);
	strcat(wfn,SWORK);
	maketemp(wfn);
	if(!(wfp = efopen(wfn,kenv.dosdos ? "w+b" : "w+")))
		terror(FUBAR);
/**/
	signal(SIGINT,(FUNCS) terror);
#ifdef	MSDOS
	ctrlbrk((FUNCP) terror);
#endif	/*MSDOS*/
/**/
	ofp = stdout;
#ifdef	USEV
	wfb = ksetvbuf(wfp,wfb,_IOFBF,kenv.blockd);
	ofb = ksetvbuf(ofp,ofb,_IOFBF,kenv.blockd);	/* reserve */
	ksetvbuf(stderr,NULL,_IOLBF,bufsiz());
#endif	/*USEV*/
/**/
	kenv.report = cmdnum(argc,argv,'v',DA,DA|DB);
/**/
	setsort(argc,argv);
	if(kenv.report & DB)	print("<sorts set>\n");
/**/
	dolist(argc,argv,readline);
/**/
	sortline(dict.numl);
	makeline( 0 );
/**/
	if(kenv.report & DB)	print("<list processed>\n");
/**/
	mergesort();
	if(kenv.report & DB)	print("<merge finished>\n");
/**/
	terror(0);
	return(0);
}
newcmp(os,is,ix,spx,fc)
char		*os;
char		*is;
int			ix;
SORTSPEC	*spx;
int			fc;
{
	auto	double	drek;
	auto	char	*obeg;
	auto	char	*oend;
	auto	char	*ibeg;
	auto	char	*iend;
	auto	int		fcn;
	auto	int		ret;
	auto	NOSIGN	sspecs = spx[ix].sspecs;
	auto	NOSIGN	sfield = spx[ix].sfield;
	auto	NOSIGN	efield = spx[ix].efield;
	auto	char	isave = 0;
	auto	char	osave = 0;
	efield = efield ? efield : (NOSIGN) ~0;
/**/
	for(ibeg = is, fcn = 0; fcn < sfield && *ibeg != 0; ibeg++)	{
		fcn = (*ibeg == (char) fc) ? (fcn + 1) : fcn;
		}
	for(iend = ibeg; fcn < efield && *iend != 0; iend++)	{
		fcn = (*iend == (char) fc) ? (fcn + 1) : fcn;
		}
	for(obeg = os, fcn = 0; fcn < sfield && *obeg != 0; obeg++)	{
		fcn = (*obeg == (char) fc) ? (fcn + 1) : fcn;
		}
	for(oend = obeg; fcn < efield && *oend != 0; oend++)	{
		fcn = (*oend == (char) fc) ? (fcn + 1) : fcn;
		}
	if(*iend != 0)	{ isave = *--iend; *iend = 0; }
	if(*oend != 0)	{ osave = *--oend; *oend = 0; }
/**/
/**/
	if(sspecs & SBLNK)	{
		while(isspace(*ibeg))	++ibeg;
		while(isspace(*obeg))	++obeg;
		}
/**/
	if(sspecs & SNUMR)	{
		drek = atof(obeg) - atof(ibeg);
		if(drek > 0.0)	ret = 1;
		else
		if(drek < 0.0)	ret = -1;
		else			ret = 0;
		}
	else	{
		REG	NOSIGN	c1;
		REG	NOSIGN	c2;
		ret = 0;
		do	{
			c1 = *obeg++;
			c2 = *ibeg++;
			if(sspecs & SDICT)	{
				while(*obeg != 0 && !isalnum(c1))	c1 = *obeg++;
				while(*ibeg != 0 && !isalnum(c2))	c2 = *ibeg++;
				}
			if(sspecs & SFOLD)	{
				c1 = toupper(c1);
				c2 = toupper(c2);
				}
			}	while(c1 == c2 && c1)	;
		ret = c1 - c2;
		}
/**/
	if(sspecs & SREVR)	{
		if(ret == 0)	;
		else
		if(ret > 0)	ret = -1;
		else
		if(ret < 0)	ret = 1;
		}
/**/
	if(isave)	*iend = isave;
	if(osave)	*oend = osave;
/**/
	return(ret);
}
sorter(s1,s2)
char	**s1;
char	**s2;
{
	auto	int	i;
	auto	int	ret = 0;
/**/
	if(*s1 == *s2)	return(ret);
/**/
	if((kenv.report & DA) && (npass % nassp == 0))	{
		fprintf(stderr,"%-20.20s\r",action);
		if(xact == strupr)	xact = strlwr;
		else				xact = strupr;
		(*xact)(action);
		fflush(stderr);
		}
/**/
	npass += 1;
/**/
	for(i = ZERO; ret == ZERO && i < nsort; i++)	{
		ret = newcmp(*s1+2,*s2+2,i,spx,fc);
		}
/**/
	return(ret);
}
sortline(nlc)	/* sort memory array, then write to work */
int		nlc;
{
	auto	int		ix;
	auto	char	*os;
/**/
	merge[npart].m_start = ftell(wfp);
	merge[npart].m_lines = nlc;
/**/
	if(kenv.report & DB)	fprintf(stderr,"part(%d) sort",npart);
/**/
	npass = 0L;
	action = "<sorting>";
	nassp = 100;
	qsort(dict.base,nlc,sizeof(char *),sorter);
/**/
	if(kenv.report & DB)	fprintf(stderr,"\n");
/**/
	if(kenv.report & DB)	fprintf(stderr,"part(%d) write",npart);
/**/
	dict.line = (char **) dict.base;
/**/
	for(ix = 0; ix < nlc; ix++)	{
		os = dict.line[ix];
		if(!(os[0] == 'S' || os[0] == 'U'))	{
			dump("sortline: bad record");
			}
		os[1] = (char) (npart + 1);		/* to avoid NULL */
		fputs(os,wfp);
		fputs("\n",wfp);
		}
	if(ferror(wfp))	{
		errmsg("sortline <writer error: disk full?>\n");
		terror(FUBAR);
		}
/**/
	if(kenv.report & DB)	fprintf(stderr,"\n");
/**/
	mpart = npart += 1;
/**/
	return(nlc = nlp = 0);
}
char	*
getmerge(ix)
int		ix;
{
/**/
	auto	char	*rs;
	static	int		last = FUBAR;
	auto	int		nf;
/**/
	if(merge[ix].m_lines <= 0)	return(NULL);
/**/
	if(ix != last) efseek(wfp,merge[ix].m_start,0);
	last = ix;
/**/
	ps[0] = getc(wfp);	/* should be 'S' or 'U' */
	ps[1] = getc(wfp);	/* file number plus 1 */
	nf = ps[1] - 1;
/**/
	if(nf < 0 || nf >= mpart)	{
		dump("getmerge: nf");
		}
/**/
	if(!fgetls(ps+2,ps+BUFSIZ-3,wfp))	{
		dump("getmerge: eof");
		return(NULL);
		}
/**/
	rs = strsave(ps);
/**/
	if(rs == NULL)	{
		errmsg("getmerge <no core>\n");
		terror(FUBAR);
		}
/**/
	merge[ix].m_lines -= 1;
	merge[ix].m_start = ftell(wfp);
/**/
	return(rs);
}
wrtmerge(lp)
char	*lp;
{
	auto	int		wr = 1;
	auto	int		nf;
/**/
	nf = lp[1] - 1;
/**/
	if(nf < 0 || nf >= mpart)	dump("wrtmerge: nf");
/**/
	if(lp[0] == 'U')	{
		free_if(lp);
		return(nf);
		}
/**/
	if(lp == NULL)	{
		errmsg("wrtmerge <NULL line pointer>\n");
		terror(FUBAR);
		}
/**/
	if(wr)	{
		fputs(lp+2,ofp);		/* write line less file number */
		fputs("\n",ofp);
		if(ferror(ofp))	{
			errmsg("wrtmerge < write error. disk full? >\n");
			terror(FUBAR);
			}
		}
	free_if(lp);
/**/
	return(nf);					/* file number */
}
mergesort()
{
	auto	int		ix;
	auto	int		jx;
	auto	long	mline = 0L;
	auto	long	tbeg;
	time(&tbeg);
/*	write to stdout or replace file? */
	if(ofn)	{
		xfclose(stdout);
		ofp = tefopen(ofn,"w");
		}
#ifdef	USEV
	ofb = ksetvbuf(ofp,ofb,_IOFBF,kenv.blockd);
#endif	/*USEV*/
/**/
	if(npart > 1)	{
/**/
		lp = (char **) emalloc( sizeof(char *) * npart ,"mergesort:lp");
/**/
		memset( (char *) lp, '\0', sizeof(char *) * npart );
/**/
		for(ix = 0; ix < npart; ix++) lp[ix] = getmerge(ix);
/**/
		while(npart > 0)						{
/**/
		npass = 0L;
		action = "<merging>";
		nassp = npart * 100;
		npass = mline;			/* fool sorter */
		if(kenv.flags0 & DA)	ssort( (char *) lp,npart,sizeof(char *),sorter);
		else					qsort( (char *) lp,npart,sizeof(char *),sorter);
/**/
		if(funiq)	isuniq(lp);
		jx = wrtmerge(lp[0]);
		if((kenv.report & DA) && (mline % nassp == 0))	{
			auto	double	percent;
			auto	long	tnow;
			auto	double	uses;
			time(&tnow);
			tnow -= tbeg;
			if(mline <= 0)	mline = 1;
			percent = (double) mline * 100.0;
			percent /= (double) tline;
			uses = (tnow / (percent / 100.0)) / 60.0;
			fprintf(stderr,"%-20.20s",action);
			fprintf(stderr," %5.1f%% need %5.2f min(s)\r", percent,uses);
			}
		mline += 1;
		lp[0] = getmerge(jx);
		if(lp[0] == NULL)	{
			for(ix = 1; ix < npart; ix++)
				lp[ix-1] = lp[ix];
			npart -= 1;
			}
/**/
		}
/**/
	}
	else	{
		rewind(wfp);
		while(!feof(wfp))	{
			ps[0] = getc(wfp);
			ps[1] = getc(wfp);
			if(!fgets(ps+2,BUFSIZ-1,wfp))	break;
			if(funiq)			isuniq(ps);
			if(ps[0] == 'S')	fputs(ps+2,ofp);
			}
		}
/**/
	return(0);
/**/
}
isuniq(is)
char	*is;
{
/*
	compare current and previous lines. if they are the same,
	mark the current line with U so it will not be written to
	the output.
*/
	static	char	*pl = NULL;
	if(pl && sorter(&is,&pl) == 0)	is[0] = 'U';
	pl = free_if(pl);
	pl = strsave(is);
	if(pl == NULL)	dump("no core: isuniq");
	return(is[0]);
}
readline(fp)		/* get the text to sort */
FILE	*fp;
{
/**/
	if(dict.base == NULL) makeline( 1 );
/**/
	ps[1] = ps[0] = 'S';		/* FUDGE */
/**/
	while(fgetls(ps+2,ps+BUFSIZ-3,fp))	{
/**/
		tline += 1;
/**/
		while(1)	{
			if(saveline(ps))	{
				sortline(dict.numl);
				makeline( 1 );
				}
			else	break;
			}
/**/
	}
/**/
	return(dict.numl);
}
char	*
getfield(os,is,sf,ef,fc)
char	*os;
char	*is;
int	sf;
int	ef;
int	fc;
{
	REG		char	*osx = os;
	REG		char	*isx = is;
	REG		int	fcx = ZERO;
/**/
	ef = ef >= 1 ? ef : HUGE;
/**/
	*osx = ZERO;
/**/
	while(*isx != ZERO)	{
		if((int) *isx == fc)	{
			fcx += 1;
			if(fcx >= ef)	break;
			}
		if(fcx >= sf)		*osx++ = *isx++;
		else				++isx;
		}
	*osx = ZERO;
	return(os);
}
char	*
blankit(is)
char	*is;
{
	REG	char	*isx = is;
	while(*isx != ZERO && isspace(*isx))	++isx;
	strcpy(is,isx);
	return(is);
}
char	*
dictit(is)
char	*is;
{
	REG	char	*osx = is;
	REG	char	*isx = is;
	while(*isx != ZERO)
	if(isalnum(*isx) || isspace(*isx))	*osx++ = *isx++;
	else					++isx;
	*osx = ZERO;
	return(is);
}
numcmp(r1,r2)	/* compare numbers */
char	*r1;
char	*r2;
{
	auto	double	n1 = atof(r1);
	auto	double	n2 = atof(r2);
	auto	double	rt;
	rt = n1 - n2;
	if(rt < 0.0)	return(-1);
	else
	if(rt > 0.0)	return(1);
	else			return(0);
}
setsort(argc,argv)
int	argc;
char	*argv[];
{
	auto	int	i;
	auto	int	np = 0;
	auto	int	nm = 0;
/**/
	ifn = NULL;
/**/
	nsort = 0;
	fc = ' ';
/**/
	for(i = 1; i < argc; i++)
		if(argv[i] && *argv[i] == '-')		{
			auto	char	*isx = argv[i] + 1;
			auto	char	zap = 0;
			while(*isx)	switch(*isx++)	{
				case	't':    fc = *isx++; zap += 1;
				when	'P':	zap += 1;
				when	'T':	zap += 1;
				when	'v':	zap += 1;
				when	'R':	zap += 1;
				when	'D':	zap += 1;
				when	'o':	zap += 1;
				when	'u':	funiq = 1; zap += 1;
				default:		break;
				}
			if(zap)	argv[i] = NULL;
			}
/**/
	for(i = 1; i < argc; i++)	
	if(!argv[i])		continue;
	else
	if(*argv[i] == '+')	{
		spx[nsort].sfield = pullfield(argv[i]+1);
		spx[nsort].efield = HUGE;
		spx[nsort].soffst = pulloffst(argv[i]+1);
		spx[nsort].sspecs |= pullflag(argv[i]+1);
		++np;
		argv[i] = NULL;
		}
	else
	if(*argv[i] == '-')	{
		spx[nsort].efield = pullfield(argv[i]+1);
		spx[nsort].eoffst = pulloffst(argv[i]+1);
		spx[nsort].sspecs |= pullflag(argv[i]+1);
		++nsort;
		++nm;
		argv[i] = NULL;
		}
/**/
	if(nsort == 0)	nsort = nm = np = 1;
/**/
	if(np && nm > np)	{
		errmsg("<more - than + in sort spec>\n");
		terror(FUBAR);
		}
/**/
	for(i = 0; i < nsort; i++)	{
		if(spx[i].sfield && spx[i].sfield >= spx[i].efield)	{
			errmsg("<start field exceeds end field> %u %u %u\n",
				i,spx[i].sfield,spx[i].efield);
			terror(FUBAR);
			}
		}
/**/
	return(nsort);
}
pullfield(is)
char	*is;
{
	return(atoi(is));
}
pulloffst(is)
char	*is;
{
	while(isdigit(*is))	++is;
	if(*is == '.')		++is;
	return(atoi(is));
}	
pullflag(is)	/* pull flags */
char	*is;
{
	REG			char	*isx;
	auto		char	flag = 0;
	for(isx = is; *isx; isx++)
	if(isdigit(*isx))	;
	else
	switch(*isx)	{
		case	'.':	break;
		case	'd':	flag |= SDICT; break;
		case	'b':	flag |= SBLNK; break;
		case	'f':	flag |= SFOLD; break;
		case	'r':	flag |= SREVR; break;
		case	'n':	flag |= SNUMR; break;
		case	'u':	flag |= SUNIQ; break;
		default:
				errmsg("pullflag <unknown flag> '%c' in '%s'\n",
					*isx,is);
				terror(FUBAR);
				break;
		}
	return(flag);
}
hint(ty)
{
static	char	*hx[] = {
"=ksort [options] [file(s)]",
"*",
"*           provides a UNIX style sort function for MSDOS",
"*",
"=STANDARD OPTIONS",
"-o file     writes the output to the specified file.",
"            *this may be one of the input files.",
"-t C        use the single character C to delimit input fields",
"            *default is a space",
"-u          write only one copy of EXACTLY equal lines to the output",
"            *option differs from UNIX sort",
"\+NN         skip NN input fields",
"            *the leftmost field is 0",
"-NN         stop at NN input fields",
"~",
"=SUPPLEMENTARY OPTIONS",
"-T dir      place work files in the named directory.  used to specify",
"            a RAM disk.",
"-vNN        specify the level of verbosity.",
"=FLAGS",
"d           dictionary sort (only spaces, digits, and alphabetic",
"            items are used)",
"f           fold (ignore case)",
"b           initial blanks are ignored",
"n           numerical sort",
"r           reversed order sort",
"=",
"~",
"=LIMITS",
"            ksort requires a work area about 5 percent greater than",
"            the total size of the file(s) to be sorted.",
"=SPEED",
"            speed is substantially improved by use of a RAMdisk.",
"=",
"~",
"=EXAMPLES",
"*           ksort -u +2 -3dfb",
"*           gives a dictionary sort on the third column, ignoring",
"*           initial blanks and case.",
"*           given the input",
"*           aaaa bbbb cccc dddd",
"*           the column cccc is the third input field",
"=BUGS",
"*           field specifications of the form field:offset are NOT",
"            currently supported.",
"*           a **IX style file (each line ends in LF) sorted under",
"            MSDOS is converted to a MSDOS style file (each line ends",
"            in CR/LF).",
"*           the -u (uniq) option eliminates duplicate lines only if",
"            the whole line is identical rather than if the specified",
"            sort fields are identical.",
"=",
}	;
	prhint(hx,sizeof(hx)/sizeof(char**),NULL,ZERO);
	exit(ty);
	return(ty);
}
void
ssort(bs,ne,wi,fu)	/* shell sort */
char	*bs;		/* structure to sort */
int		ne;			/* number of elements */
int		wi;			/* width of an element */
int		(*fu)();	/* comparison function */
{
	auto	int		gap;
	auto	int		ix;
	auto	int		jx;
	auto	char	crap[32];
	ne *= wi;
	for(gap = ne / 2; gap > 0; gap /= 2)
		for(ix = gap; ix < ne; ix += wi)
			for(jx = ix - gap; jx >= 0; jx -= gap)	{
				if( (*fu) ( bs + jx, bs + jx + gap ) <= 0)	break;
				memcpy(crap, bs + jx, wi);
				memcpy(bs + jx, bs + jx + gap, wi);
				memcpy(bs + jx + gap, crap, wi);
				}
	return;
}
#ifdef		MSDOS
void
showstat(fp)
FILE	*fp;
{
	extern	unsigned	_stklen;
	extern	unsigned	_heaplen;
	extern	int			_8087;
	fprintf(fp,"stack(%u) heap(%u) math(%d)\n",
		_stklen,_heaplen,_8087);
	return;
}
#endif		/*MSDOS*/
saveline(is)
char	*is;
{
	auto	unsigned	ls = strlen(is) + 1;
/*	
	if this is not rounded up, it causes alignment problems
*/
	ls = (ls % 2) ? (ls + 1) : ls;
	dict.data -= ls;
	if((char *) dict.line >= dict.data)	return(1);	/* full */
	*dict.line = strcpy(dict.data,is);
	dict.line += 1;
	dict.numl += 1;
	return(0);
}
void
makeline(nc)
NOSIGN	nc;
{
	dict.base = dict.data = free_if(dict.base);
	dict.line = (char **) NULL;
	dict.numl = dict.size = 0;
	if(nc)	{
		auto	long		maxmem;
		auto	long		maxinc;
		if(sizeof(char *) == 2)	maxmem = 1L << 16;
		else					maxmem = 1L << 20;
		maxinc = maxmem / 8;
		nc = maxinc;
		while(nc <= maxmem)	{
			dict.base = (char *) malloc(nc);
			if(dict.base != NULL)	{
				dict.base = free_if(dict.base);
				nc += maxinc;
				continue;
				}
			else	break;
			}
		if(dict.base)	free(dict.base);
		nc -= maxinc;
		dict.base = emalloc( nc, "makeline" );
		dict.data = dict.base + nc;
		dict.line = (char **) dict.base;
		dict.size = nc;
		if(kenv.report & DB)	{
			prwho("makeline <core for sort> %u\n",nc);
			}
		}
	return;
}
void
dumpline(fp)
FILE	*fp;
{
	register	char	**osx = (char **) dict.base;
	register	char	**usx = (char **) dict.line;
	while(osx < usx)	{
		fputs(*osx++,fp);
		fputs("\n",fp);
		}
	makeline( 1 );
	return;
}
