/*
**	to add news functions, make entries in the
**	extern list
**	BUILTIN list
*/
#include	"ksysdefs.h"
#include	"ksysvtyp.h"
#include	"kawkdefs.h"
/**/
#include	"ksysprot.h"
#include	"kawkfunc.h"
/**/
extern	void	kstrnicmp();
extern	void	kstricmp();
extern	void	esprt();
extern	void	kxtocd();
extern	void	kcdtox();
extern	void	kcrchash();
extern	void	kcrcsum();
extern	void	krand();
extern	void	kstrtime();
extern	void	kfgetlerr();
extern  void	kfseek();
/**/
struct	BUILTIN	{
	FUNCP	bif;		/* function to call */
	char	*bin;		/* name of function */
	char	pmin;		/* mininum # of parameters */
	char	pmax;		/* maximum # of parameters */
	} bf[] = {
/*BEGIN_BUILTIN*/
(FUNCP) esprt, "esprt", 0, 0,
(FUNCP) kcdtox, "cdtox", 2, 2,
(FUNCP) kxtocd, "xtocd", 2, 2,
(FUNCP) kcrcsum, "crcsum", 1, 2,
(FUNCP) kcrchash, "crchash", 2, 2,
(FUNCP) kfseek, "fseek", 3, 3,
(FUNCP) kfgetlerr, "fgetlerr", 0, 0,
(FUNCP) kstrtime, "strtime", 3, 3,
(FUNCP) krand, "rand", 0, 0,
(FUNCP) kclcard, "clcd", 0, 0,
(FUNCP) kclcard, "clcard", 0, 0,
(FUNCP) kexpand, "expand", 2, 2,
(FUNCP) kabort, "abort", 0, 1,
(FUNCP) kaccess, "access", 2, 2,
(FUNCP) kandlist, "andlist", 3, 3,
(FUNCP) katof, "atof", 1, 1,
(FUNCP) katoi, "atoi", 1, 1,
(FUNCP) kbshpat, "bshpat", 2, 2,
(FUNCP) kcapital, "capital", 1, 1,
(FUNCP) kcdcond, "cdcond", 1, 1,
(FUNCP) kcdsize, "cdsize", 0, 0,
(FUNCP) kchange, "change", 6, 6,
(FUNCP) kchrcnt, "chrcnt", 2, 2,
(FUNCP) kchrcnt, "strcnt", 2, 2,
(FUNCP) kcindex, "cindex", 2, 2,
(FUNCP) kcmdnum, "cmdnum", 3, 3,
(FUNCP) kcmdstr, "cmdstr", 3, 3,
(FUNCP) kcount, "count", 0, 0,
(FUNCP) kcrindex, "crindex", 2, 2,
(FUNCP) kdater, "dater", 3, 3,
(FUNCP) kdgetsub, "dgetsub", 5, 5,
(FUNCP) kdrawline, "drawline", 2, 2,
(FUNCP) kexit, "exit", 1, 1,
(FUNCP) kfclose, "fclose", 0, 1,
(FUNCP) kfflush, "fflush", 0, 0,
(FUNCP) kfgetlf, "fgetlf", 2, 3,
(FUNCP) kfgetls, "fgetls", 2, 3,
(FUNCP) kfilemod, "filemod", 1, 1,
(FUNCP) kfilenum, "filenum", 0, 0,
(FUNCP) kfilesize, "filesize", 1, 1,
(FUNCP) kfopen, "fopen", 2, 2,
(FUNCP) kfprintf, "fprintf", 1, 127,
(FUNCP) kfputs, "fputs", 1, 2,
(FUNCP) kgetc, "getc", 2, 2,
(FUNCP) kgetchar, "getchar", 0, 0,
(FUNCP) kgetcwd, "getcwd", 0, 0,
(FUNCP) kgetqs, "getqs", 4, 4,
(FUNCP) kgetrex, "getrex", 2, 2,
(FUNCP) khaspat, "haspat", 2, 2,
(FUNCP) kindex, "index", 2, 2,
(FUNCP) kindex, "strchr", 2, 2,
(FUNCP) kinfile, "infile", 0, 1,
(FUNCP) kisalnum, "isalnum", 1, 1,
(FUNCP) kisalpha, "isalpha", 1, 1,
(FUNCP) kiscntrl, "iscntrl", 1, 1,
(FUNCP) kisdigit, "isdigit", 1, 1,
(FUNCP) kiskey, "iskey", 1, 1,
(FUNCP) kislower, "islower", 1, 1,
(FUNCP) kisnull, "isnull", 1, 1,
(FUNCP) kisprint, "isprint", 1, 1,
(FUNCP) kispunct, "ispunct", 1, 1,
(FUNCP) kisspace, "isspace", 1, 1,
(FUNCP) kisupper, "isupper", 1, 1,
(FUNCP) kkchdir, "kchdir", 1, 1,
(FUNCP) kkeycat, "keycat", 2, 3,
(FUNCP) kkeycnt, "keycnt", 0, 0,
(FUNCP) kkeytac, "keytac", 2, 3,
(FUNCP) kkeyzap, "keyzap", 1, 127,
(FUNCP) kkgetenv, "getenv", 1, 1,
(FUNCP) kkgetsub, "kgetsub", 4, 4,
(FUNCP) kputsf, "putsf", 1, 3,
(FUNCP) kkuso, "kuso", 1, 1,
(FUNCP) kkusopipe, "kusopipe", 1, 1,
(FUNCP) klink, "link", 2, 2,
(FUNCP) kfunxesc, "funxesc", 1, 2,
(FUNCP) klitrep, "litrep", 6, 6,
(FUNCP) klsrdcd, "lsrdcd", 1, 1,
(FUNCP) kmaximum, "maximum", 2, 127,
(FUNCP) kminimum, "minimum", 2, 127,
(FUNCP) kmktemp, "maketemp", 1, 1,
(FUNCP) kmktemp, "mktemp", 1, 1,
(FUNCP) knextkey, "nextkey", 1, 1,
(FUNCP) knumstr, "numstr", 1, 1,
(FUNCP) korlist, "orlist", 2, 127,
(FUNCP) kpclose, "pclose", 0, 0,
(FUNCP) kpipe, "pipe", 1, 1,
(FUNCP) kprint, "print", 0, 127,
(FUNCP) kprintf, "printf", 1, 127,
(FUNCP) kprtsym, "prtsym", 0, 0,
(FUNCP) kputchar, "putchar", 1, 1,
(FUNCP) kputs, "puts", 1, 2,
(FUNCP) krdcard, "rdcd", 0, 1,
(FUNCP) krdcard, "rdcard", 0, 1,
(FUNCP) krdline, "rdline", 2, 3,
(FUNCP) krdterm, "rdterm", 3, 3,
(FUNCP) kreverse, "reverse", 3, 3,
(FUNCP) krewind, "rewind", 0, 1,
(FUNCP) krindex, "rindex", 2, 2,
(FUNCP) krindex, "strrchr", 2, 2,
(FUNCP) ksetdiag, "setdiag", 1, 1,
(FUNCP) ksetfile, "setfile", 1, 1,
(FUNCP) ksetfold, "setfold", 1, 1,
(FUNCP) ksetifn, "setifn", 0, 1,
(FUNCP) ksetked, "setked", 0, 1,
(FUNCP) ksetofn, "setofn", 0, 2,
(FUNCP) ksetrep, "setrep", 1, 1,
(FUNCP) ksetrex, "setrex", 1, 1,
(FUNCP) ksetwork, "setwork", 1, 1,
(FUNCP) ksformat, "sformat", 3, 127,
(FUNCP) ksformat, "sprintf", 3, 127,
(FUNCP) ksgetsub, "sgetsub", 6, 6,
(FUNCP) ksleep, "sleep", 1, 1,
(FUNCP) kslowit, "query", 0, 1,
(FUNCP) kslowit, "slowit", 0, 1,
(FUNCP) ksource, "source", 1, 1,
(FUNCP) ksplitc, "splitc", 4, 4,
(FUNCP) kstrcat, "strcat", 2, 2,
(FUNCP) kstrnicmp, "strnicmp", 2, 3,
(FUNCP) kstricmp, "stricmp", 2, 2,
(FUNCP) kstrcmp, "strcmp", 2, 2,
(FUNCP) kstrcnd, "strcnd", 1, 1,
(FUNCP) kstrcpy, "strcpy", 2, 2,
(FUNCP) kstrfold, "strfold", 2, 2,
(FUNCP) kstrfree, "strfree", 1, 1,
(FUNCP) kstrget, "strget", 4, 4,
(FUNCP) kstrhow, "numhow", 0, 0,
(FUNCP) kstrhow, "strhow", 0, 0,
(FUNCP) kstrkat, "strkat", 3, 3,
(FUNCP) kstrkmp, "strkmp", 2, 2,
(FUNCP) kstrlen, "strlen", 1, 1,
(FUNCP) kstrloc, "strloc", 2, 2,
(FUNCP) kstrlwr, "strlwr", 1, 1,
(FUNCP) kstrncat, "strncat", 3, 3,
(FUNCP) kstrncmp, "strncmp", 3, 3,
(FUNCP) kstrncpy, "strncpy", 3, 3,
(FUNCP) kstrnkmp, "strnkmp", 3, 3,
(FUNCP) kstrnrev, "strnrev", 2, 2,
(FUNCP) kstrnum, "strnum", 1, 1,
(FUNCP) kstrrev, "strrev", 1, 1,
(FUNCP) kstrsave, "strsave", 1, 1,
(FUNCP) kstrupr, "strupr", 1, 1,
(FUNCP) kstrxty, "strxty", 3, 3,
(FUNCP) ksystem, "system", 0, 3,
(FUNCP) ktoalnum, "toalnum", 1, 1,
(FUNCP) ktranspose, "transpose", 3, 3,
(FUNCP) kundater, "undater", 3, 3,
(FUNCP) kungetc, "ungetc", 2, 2,
(FUNCP) kunlink, "unlink", 1, 1,
(FUNCP) kuserex, "userex", 1, 1,
(FUNCP) kwords, "words", 1, 1,
(FUNCP) kwrcard, "wrcd", 0, 1,
(FUNCP) kwrcard, "wrcard", 0, 1,
(FUNCP) kwt, "wt", 0, 1,
(FUNCP) kxgnc, "xgnc", 4, 4,
(FUNCP) kxrdcd, "xrdcd", 2, 3,
(FUNCP) kxwrcd, "xwrcd", 1, 2,
(FUNCP) compile, "compile", 1, 1,
/*END_BUILTIN*/
NULL,NULL,
}	;
/**/
naerror(is,n1,n2,n3)
char    *is;        /* routine name */
NOSIGN	n1;
NOSIGN	n2;
NOSIGN	n3;
{
    errmsg("%s <parameter error> %d %d <= %d\n",
        is,n1,n2,n3);
    terror(FUBAR);
    return(ZERO);
}
/**/
static	struct	BUILTIN	*lastfu;
char	*	
namefunc(func)	/* get name from address */
FUNCP	func;
{
	REG		struct	BUILTIN	*bfx = bf;
/**/
	while(bfx->bif != (FUNCP) NULL)	{
		if(bfx->bif == func)	return(bfx->bin);
		bfx += 1;
	}
/**/
	return( NULL );
}
FUNCP	
isbuiltin(is)	/* does _is name a built in function */
char	*is;
{
	REG		struct	BUILTIN	*bfx = bf;
/**/
	while(bfx->bif != (FUNCP) NULL)	{
		if(*bfx->bin == *is &&
			strcmp(bfx->bin,is) == 0)	{
				lastfu = bfx;
				return(bfx->bif);
				}
		bfx += 1;
	}
/**/
	return( (FUNCP) NULL );
}
/**/
paramchk(fu,np)	/* check for allowable number of parameters */
FUNCP	fu;		/* function to be checked */
NOSIGN	np;		/* number of parameters */
{
	REG	struct	BUILTIN	*bfx = bf;
/**/
	if(fu == lastfu->bif)	bfx = lastfu;
	else	{
			while(bfx->bif != (FUNCP) NULL)	{
				if(bfx->bif == fu)	break;
				bfx += 1;
			}
	}
/**/
	if(bfx->bif == (FUNCP) NULL)	{
		errmsg("paramchk <cannot find function>\n");
		terror(FUBAR);
		}
/**/
	if(np > bfx->pmax  || np < bfx->pmin)	{
		errmsg("paramchk <bad function call> %s(%u %u %u)\n",
			bfx->bin, bfx->pmin, np, bfx->pmax);
		return(1);
		}
	else	{
		return(ZERO);
		}
/**/
}
