#include    "ksysdefs.h"
#include    "ksysvtyp.h"
#include    "kawkdefs.h"
/**/
#include	"ksysprot.h"
#include	"kawkfunc.h"
/**/
/*EXTERN*/
void
kstrloc(na,ap)
int		na;
DATUM	*ap;
{
	rdx.v.ptr = strloc(ap[0].v.ptr,ap[1].v.ptr);
	pusher = spush;
}
void
ksleep(na,ap)
int		na;
DATUM	*ap;
{
	rdx.v.ivalu = sleep(ap[0].v.ivalu);
	pusher = ipush;
}
void
kstrlen(na,ap)
int     na;
DATUM   *ap;
{
    rdx.v.ivalu = strlen(ap[0].v.ptr);
    pusher = ipush;
}
void
kindex(na,ap)
int     na;
DATUM   *ap;
{
    rdx.v.ptr = strchr(ap[0].v.ptr,ap[1].v.ivalu);
    pusher = spush;
}
void
krindex(na,ap)
int     na;
DATUM   *ap;
{
    rdx.v.ptr = strrchr(ap[0].v.ptr,ap[1].v.ivalu);
    pusher = spush;
}
void
kreverse(na,ap)     /* reverse name strings */
int     na;
DATUM   *ap;
{
/*
**  CTEXT
**  ap[0].v.ptr should be ap[0].v.ptr; former gives
**  illegal operand message
*/
    rdx.v.ptr = reverse(ap[0].v.ptr,ap[0].v.ptr+ap[1].v.ivalu,ap[2].v.ptr);
    pusher = spush;
}
void
kandlist(na,ap)
int     na;
DATUM   *ap;
{
    rdx.v.ptr = andlist(ap[0].v.ptr,ap[0].v.ptr+ap[1].v.ivalu,ap[2].v.ptr);
    pusher = spush;
}
void
kstrrev(na,ap)
int     na;
DATUM   *ap;
{
	rdx.v.ptr = strrev(ap[0].v.ptr);
    pusher = spush;
}
void
kstrnrev(na,ap)
int     na;
DATUM   *ap;
{
	rdx.v.ptr = strnrev(ap[0].v.ptr,ap[1].v.ivalu);
    pusher = spush;
}
#ifdef	__MIDDLE__
void
kstrtime(na,ap)
int		na;
DATUM	*ap;
{
	auto	char	*os = ap[0].v.ptr;
	auto	char	*us = os + ap[1].v.ivalu;
	auto	char	*is = ap[2].v.ptr;
/**/
	rdx.v.ptr = strtime(os,us,is,0L);
	pusher = spush;
/**/
}
void
kprtsym(na,ap)          /* dump the symbol table */
int     na;
DATUM   *ap;
{
    rdx.v.ivalu = (int) prtsym(stdout);
    pusher = ipush;
}
void
kabort(na,ap)           /* force core dump */
int		na;
DATUM   *ap;
{
    if(na >= 1) dump(ap[0].v.ptr);
    else        dump("FUBAR");
}
void
kwt(na,ap)              /* write to the terminal */
DATUM   *ap;
{
    if(na >= 1) fputs(ap[0].v.ptr,stderr);
    else        fputs("\007? ",stderr);
    rdx.v.ivalu = 0;
    pusher = ipush;
}
void
ksetrep(na,ap)		/* set kenv.report */
int		na;
DATUM	*ap;
{
	kenv.report = rdx.v.ivalu = ap[0].v.ivalu;
	pusher = ipush;
}
void
ksetdiag(na,ap)		/* set kenv.diagno */
int		na;
DATUM	*ap;
{
	kenv.diagno = rdx.v.ivalu = ap[0].v.ivalu;
	pusher = ipush;
}
#else
void
kwt()
{
	notimp("strtime");
}
void
kwt()
{
	notimp("kwt");
}
void
kprtsym()
{
	notimp("prtsym");
}
void
kabort()
{
	notimp("abort");
}
void
ksetrep()
{
	notimp("setrep");
}
void
ksetdiag()
{
	notimp("setdiag");
}
#endif	/* __MIDDLE__ */
