#include	"ksysdefs.h"
#include	"ksysvtyp.h"
#include	"ksysprot.h"
#include	"kroffdef.h"
#include	"kroffvar.h"
/**/
#ifndef		ZERO	
#define		ZERO	0
#endif
#define     HI      9999
#define     LO      0
#define     FUBAR   69
#define     NLIST   32
/*EXTERNAL*/
/*STATIC*/
static  char    *psx;
static  char    *msg1 = "cklist: <bad page list> '%s'\n";
static  int     nl;
static  int     up;     /* last page to print */
static  struct  OL  {
	unsigned    hip;
	unsigned    lop;
}   pages[NLIST];
#ifdef  TEST
main()
{
	char    ls[BLKSIZ];
	while(putchar('?'),gets(ls))
	switch(ls[0])   {
	case    'q':    exit(0);
	case    'o':    mklist(ls+1);
					prlist();
					break;
	case    'i':    printf("%d\n",inlist(atoi(ls+1)));
					break;
	default:        printf("\007??\n");
					break;
	}
}
prlist()
{
	int i;
	for(i = 0; i < nl; i++)
	printf("%5u - %5u\n",pages[i].lop,pages[i].hip);
	return;
}
filewalk(n)
unsigned    n;
{
	puts("\007TURKEY\007");
	abort(abm("filewalk"));
}
#endif
inlist(pn)  /* is page n in the list */
int    pn;
{
	register    int    i = 0;
	register    int    nlx = nl;
	register    int    nx = pn;
	if(nx > up) return(-1);
	for(i = 0; i < nlx; i++)
	if(nx >= pages[i].lop && nx <= pages[i].hip)    return(1);
	return(0);
}
mklist(is)  /* parse olist: -a,b,c-d,e- */
char    *is;
{
	register    char    *isx = is;
	register    char    *osx = is;
	while(*isx != ZERO)
	if(isspace(*isx))   ++isx;
	else                *osx++ = *isx++;
	*osx = ZERO;
	isx = is;
	nl = 0;
	for(;;) {
	isx = mklist1(isx) ;
	nl += 1;
	if(*isx == ZERO)    break;
	else
	if(*isx != ',') {
		errmsg(msg1,is);
		filewalk();
		}
	isx += 1;
	}
	cklist(is);
	return(nl);
}
static
cklist(is)
char    *is;
{
	register    unsigned    i = 0;
	register    unsigned    nlx = 0;
	up = 0;
	for(nlx = nl, i = 0; i < nlx; i++)
	if(pages[i].lop > pages[i].hip) {
		errmsg(msg1,is);
		filewalk();
		}
	for(nlx = nl, i = 1; i < nlx; i++)  {
		if(pages[i].lop <= pages[i-1].hip)  {
			errmsg(msg1,is);
			filewalk();
			}
	}
	for(nlx = nl, i = 0; i < nlx; i++)  {
		up = pages[i].hip > up ? pages[i].hip : up;
	}
	return(0);
}
char	*
mklist1(is)
char    *is;
{
	pages[nl].lop = LO;
	psx = is;
	if(isdigit(*psx))   pages[nl].lop = mklist2(psx);
	pages[nl].hip = pages[nl].lop;
	if(*psx == '-') {
		pages[nl].hip = HI;
		psx += 1;
		}
	if(isdigit(*psx))   pages[nl].hip = mklist2(psx);
	return(psx);
}
mklist2(is)
char    *is;
{
	register    char    *isx = is;
	int n = atoi(isx);
	while(isdigit(*isx))    ++isx;
	psx = isx;
	return(n);
}
